// See http://docs.sequelizejs.com/en/latest/docs/models-definition/
// for more of what you can do here.
const Sequelize = require('sequelize');
const DataTypes = Sequelize.DataTypes;

module.exports = function (app) {
  const sequelizeClient = app.get('sequelizeClient');
  const products = sequelizeClient.define('products', {
  
    product_id: { type: DataTypes.INTEGER, allowNull: false, primaryKey: true,},  
    product_code: { type: DataTypes.CHAR, allowNull: false},
    status: { type: DataTypes.CHAR, allowNull: false},
    list_price: { type: DataTypes.DECIMAL, allowNull: false},  

    
}, { tableName : 'idgs_products', timestamps: false, //removeAttribute: true
},
    
    {
    hooks: {
      beforeCount(options) {
        options.raw = true;
      }
    }

  });


  //products.removeAttribute ('product_id');

  // eslint-disable-next-line no-unused-vars
  products.associate = function (models) {

      products.hasMany(models.productdescriptions, { 
          //as: 'Categories',
          foreignKey:'product_id',
          sourceKey: 'product_id'
      });

      products.hasMany(models.productprices, { 
        //as: 'Categories',
        foreignKey:'product_id',
        sourceKey: 'product_id'
    }); 

   /*     products.belongsTo(models.productDescription, { 
        //as: 'Categories',
        foreignKey:'product_id',
    }); 
   */
     
    // Define associations here
    // See http://docs.sequelizejs.com/en/latest/docs/associations/
  };



  return products;

};
